#ifndef _H_78339B145FE2F9FE005EF381EC4E10A9_ButtonEvent_DCPS_H_
#define _H_78339B145FE2F9FE005EF381EC4E10A9_ButtonEvent_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ButtonEvent_.h"


namespace kobuki_ros_interfaces
{
    namespace msg
    {
        namespace dds_
        {
            class ButtonEvent_TypeSupportInterface;

            typedef ButtonEvent_TypeSupportInterface * ButtonEvent_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ButtonEvent_TypeSupportInterface> ButtonEvent_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ButtonEvent_TypeSupportInterface> ButtonEvent_TypeSupportInterface_out;


            class ButtonEvent_DataWriter;

            typedef ButtonEvent_DataWriter * ButtonEvent_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ButtonEvent_DataWriter> ButtonEvent_DataWriter_var;
            typedef DDS_DCPSInterface_out < ButtonEvent_DataWriter> ButtonEvent_DataWriter_out;


            class ButtonEvent_DataReader;

            typedef ButtonEvent_DataReader * ButtonEvent_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ButtonEvent_DataReader> ButtonEvent_DataReader_var;
            typedef DDS_DCPSInterface_out < ButtonEvent_DataReader> ButtonEvent_DataReader_out;


            class ButtonEvent_DataReaderView;

            typedef ButtonEvent_DataReaderView * ButtonEvent_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ButtonEvent_DataReaderView> ButtonEvent_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ButtonEvent_DataReaderView> ButtonEvent_DataReaderView_out;

            struct ButtonEvent_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < ButtonEvent_, struct ButtonEvent_Seq_uniq_> ButtonEvent_Seq;
            typedef DDS_DCPSSequence_var < ButtonEvent_Seq> ButtonEvent_Seq_var;
            typedef DDS_DCPSSequence_out < ButtonEvent_Seq> ButtonEvent_Seq_out;

            class  ButtonEvent_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ButtonEvent_TypeSupportInterface_ptr _ptr_type;
                typedef ButtonEvent_TypeSupportInterface_var _var_type;

                static ButtonEvent_TypeSupportInterface_ptr _duplicate (ButtonEvent_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ButtonEvent_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ButtonEvent_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ButtonEvent_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ButtonEvent_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ButtonEvent_TypeSupportInterface () {};
                ~ButtonEvent_TypeSupportInterface () {};
            private:
                ButtonEvent_TypeSupportInterface (const ButtonEvent_TypeSupportInterface &);
                ButtonEvent_TypeSupportInterface & operator = (const ButtonEvent_TypeSupportInterface &);
            };

            class  ButtonEvent_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ButtonEvent_DataWriter_ptr _ptr_type;
                typedef ButtonEvent_DataWriter_var _var_type;

                static ButtonEvent_DataWriter_ptr _duplicate (ButtonEvent_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ButtonEvent_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ButtonEvent_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ButtonEvent_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ButtonEvent_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ButtonEvent_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ButtonEvent_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ButtonEvent_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ButtonEvent_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ButtonEvent_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ButtonEvent_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ButtonEvent_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ButtonEvent_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ButtonEvent_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ButtonEvent_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ButtonEvent_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ButtonEvent_& instance_data) = 0;

            protected:
                ButtonEvent_DataWriter () {};
                ~ButtonEvent_DataWriter () {};
            private:
                ButtonEvent_DataWriter (const ButtonEvent_DataWriter &);
                ButtonEvent_DataWriter & operator = (const ButtonEvent_DataWriter &);
            };

            class  ButtonEvent_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ButtonEvent_DataReader_ptr _ptr_type;
                typedef ButtonEvent_DataReader_var _var_type;

                static ButtonEvent_DataReader_ptr _duplicate (ButtonEvent_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ButtonEvent_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ButtonEvent_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ButtonEvent_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ButtonEvent_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ButtonEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ButtonEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ButtonEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ButtonEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ButtonEvent_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ButtonEvent_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ButtonEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ButtonEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ButtonEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ButtonEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ButtonEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ButtonEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ButtonEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ButtonEvent_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ButtonEvent_& instance) = 0;

            protected:
                ButtonEvent_DataReader () {};
                ~ButtonEvent_DataReader () {};
            private:
                ButtonEvent_DataReader (const ButtonEvent_DataReader &);
                ButtonEvent_DataReader & operator = (const ButtonEvent_DataReader &);
            };

            class  ButtonEvent_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ButtonEvent_DataReaderView_ptr _ptr_type;
                typedef ButtonEvent_DataReaderView_var _var_type;

                static ButtonEvent_DataReaderView_ptr _duplicate (ButtonEvent_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ButtonEvent_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ButtonEvent_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ButtonEvent_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ButtonEvent_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ButtonEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ButtonEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ButtonEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ButtonEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ButtonEvent_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ButtonEvent_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ButtonEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ButtonEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ButtonEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ButtonEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ButtonEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ButtonEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ButtonEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ButtonEvent_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ButtonEvent_& instance) = 0;

            protected:
                ButtonEvent_DataReaderView () {};
                ~ButtonEvent_DataReaderView () {};
            private:
                ButtonEvent_DataReaderView (const ButtonEvent_DataReaderView &);
                ButtonEvent_DataReaderView & operator = (const ButtonEvent_DataReaderView &);
            };
        }

    }

}

#endif
