#ifndef _H_A3CF937A529A7224830A4356BB39A146_ExternalPower_DCPS_H_
#define _H_A3CF937A529A7224830A4356BB39A146_ExternalPower_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ExternalPower_.h"


namespace kobuki_ros_interfaces
{
    namespace msg
    {
        namespace dds_
        {
            class ExternalPower_TypeSupportInterface;

            typedef ExternalPower_TypeSupportInterface * ExternalPower_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ExternalPower_TypeSupportInterface> ExternalPower_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ExternalPower_TypeSupportInterface> ExternalPower_TypeSupportInterface_out;


            class ExternalPower_DataWriter;

            typedef ExternalPower_DataWriter * ExternalPower_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ExternalPower_DataWriter> ExternalPower_DataWriter_var;
            typedef DDS_DCPSInterface_out < ExternalPower_DataWriter> ExternalPower_DataWriter_out;


            class ExternalPower_DataReader;

            typedef ExternalPower_DataReader * ExternalPower_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ExternalPower_DataReader> ExternalPower_DataReader_var;
            typedef DDS_DCPSInterface_out < ExternalPower_DataReader> ExternalPower_DataReader_out;


            class ExternalPower_DataReaderView;

            typedef ExternalPower_DataReaderView * ExternalPower_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ExternalPower_DataReaderView> ExternalPower_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ExternalPower_DataReaderView> ExternalPower_DataReaderView_out;

            struct ExternalPower_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < ExternalPower_, struct ExternalPower_Seq_uniq_> ExternalPower_Seq;
            typedef DDS_DCPSSequence_var < ExternalPower_Seq> ExternalPower_Seq_var;
            typedef DDS_DCPSSequence_out < ExternalPower_Seq> ExternalPower_Seq_out;

            class  ExternalPower_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ExternalPower_TypeSupportInterface_ptr _ptr_type;
                typedef ExternalPower_TypeSupportInterface_var _var_type;

                static ExternalPower_TypeSupportInterface_ptr _duplicate (ExternalPower_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ExternalPower_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ExternalPower_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ExternalPower_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ExternalPower_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ExternalPower_TypeSupportInterface () {};
                ~ExternalPower_TypeSupportInterface () {};
            private:
                ExternalPower_TypeSupportInterface (const ExternalPower_TypeSupportInterface &);
                ExternalPower_TypeSupportInterface & operator = (const ExternalPower_TypeSupportInterface &);
            };

            class  ExternalPower_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ExternalPower_DataWriter_ptr _ptr_type;
                typedef ExternalPower_DataWriter_var _var_type;

                static ExternalPower_DataWriter_ptr _duplicate (ExternalPower_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ExternalPower_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ExternalPower_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ExternalPower_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ExternalPower_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ExternalPower_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ExternalPower_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ExternalPower_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ExternalPower_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ExternalPower_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ExternalPower_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ExternalPower_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ExternalPower_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ExternalPower_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ExternalPower_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ExternalPower_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ExternalPower_& instance_data) = 0;

            protected:
                ExternalPower_DataWriter () {};
                ~ExternalPower_DataWriter () {};
            private:
                ExternalPower_DataWriter (const ExternalPower_DataWriter &);
                ExternalPower_DataWriter & operator = (const ExternalPower_DataWriter &);
            };

            class  ExternalPower_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ExternalPower_DataReader_ptr _ptr_type;
                typedef ExternalPower_DataReader_var _var_type;

                static ExternalPower_DataReader_ptr _duplicate (ExternalPower_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ExternalPower_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ExternalPower_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ExternalPower_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ExternalPower_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ExternalPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ExternalPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ExternalPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ExternalPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ExternalPower_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ExternalPower_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ExternalPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ExternalPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ExternalPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ExternalPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ExternalPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ExternalPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ExternalPower_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ExternalPower_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ExternalPower_& instance) = 0;

            protected:
                ExternalPower_DataReader () {};
                ~ExternalPower_DataReader () {};
            private:
                ExternalPower_DataReader (const ExternalPower_DataReader &);
                ExternalPower_DataReader & operator = (const ExternalPower_DataReader &);
            };

            class  ExternalPower_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ExternalPower_DataReaderView_ptr _ptr_type;
                typedef ExternalPower_DataReaderView_var _var_type;

                static ExternalPower_DataReaderView_ptr _duplicate (ExternalPower_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ExternalPower_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ExternalPower_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ExternalPower_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ExternalPower_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ExternalPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ExternalPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ExternalPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ExternalPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ExternalPower_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ExternalPower_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ExternalPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ExternalPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ExternalPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ExternalPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ExternalPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ExternalPower_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ExternalPower_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ExternalPower_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ExternalPower_& instance) = 0;

            protected:
                ExternalPower_DataReaderView () {};
                ~ExternalPower_DataReaderView () {};
            private:
                ExternalPower_DataReaderView (const ExternalPower_DataReaderView &);
                ExternalPower_DataReaderView & operator = (const ExternalPower_DataReaderView &);
            };
        }

    }

}

#endif
