#ifndef _H_9163C284CFED43190CA8FDCADA31C73A_BumperEvent_DCPS_H_
#define _H_9163C284CFED43190CA8FDCADA31C73A_BumperEvent_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "BumperEvent_.h"


namespace kobuki_ros_interfaces
{
    namespace msg
    {
        namespace dds_
        {
            class BumperEvent_TypeSupportInterface;

            typedef BumperEvent_TypeSupportInterface * BumperEvent_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < BumperEvent_TypeSupportInterface> BumperEvent_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < BumperEvent_TypeSupportInterface> BumperEvent_TypeSupportInterface_out;


            class BumperEvent_DataWriter;

            typedef BumperEvent_DataWriter * BumperEvent_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < BumperEvent_DataWriter> BumperEvent_DataWriter_var;
            typedef DDS_DCPSInterface_out < BumperEvent_DataWriter> BumperEvent_DataWriter_out;


            class BumperEvent_DataReader;

            typedef BumperEvent_DataReader * BumperEvent_DataReader_ptr;
            typedef DDS_DCPSInterface_var < BumperEvent_DataReader> BumperEvent_DataReader_var;
            typedef DDS_DCPSInterface_out < BumperEvent_DataReader> BumperEvent_DataReader_out;


            class BumperEvent_DataReaderView;

            typedef BumperEvent_DataReaderView * BumperEvent_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < BumperEvent_DataReaderView> BumperEvent_DataReaderView_var;
            typedef DDS_DCPSInterface_out < BumperEvent_DataReaderView> BumperEvent_DataReaderView_out;

            struct BumperEvent_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < BumperEvent_, struct BumperEvent_Seq_uniq_> BumperEvent_Seq;
            typedef DDS_DCPSSequence_var < BumperEvent_Seq> BumperEvent_Seq_var;
            typedef DDS_DCPSSequence_out < BumperEvent_Seq> BumperEvent_Seq_out;

            class  BumperEvent_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef BumperEvent_TypeSupportInterface_ptr _ptr_type;
                typedef BumperEvent_TypeSupportInterface_var _var_type;

                static BumperEvent_TypeSupportInterface_ptr _duplicate (BumperEvent_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static BumperEvent_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static BumperEvent_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static BumperEvent_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                BumperEvent_TypeSupportInterface_ptr _this () { return this; }


            protected:
                BumperEvent_TypeSupportInterface () {};
                ~BumperEvent_TypeSupportInterface () {};
            private:
                BumperEvent_TypeSupportInterface (const BumperEvent_TypeSupportInterface &);
                BumperEvent_TypeSupportInterface & operator = (const BumperEvent_TypeSupportInterface &);
            };

            class  BumperEvent_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef BumperEvent_DataWriter_ptr _ptr_type;
                typedef BumperEvent_DataWriter_var _var_type;

                static BumperEvent_DataWriter_ptr _duplicate (BumperEvent_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static BumperEvent_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static BumperEvent_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static BumperEvent_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                BumperEvent_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const BumperEvent_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const BumperEvent_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const BumperEvent_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const BumperEvent_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const BumperEvent_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const BumperEvent_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const BumperEvent_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const BumperEvent_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const BumperEvent_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const BumperEvent_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (BumperEvent_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const BumperEvent_& instance_data) = 0;

            protected:
                BumperEvent_DataWriter () {};
                ~BumperEvent_DataWriter () {};
            private:
                BumperEvent_DataWriter (const BumperEvent_DataWriter &);
                BumperEvent_DataWriter & operator = (const BumperEvent_DataWriter &);
            };

            class  BumperEvent_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef BumperEvent_DataReader_ptr _ptr_type;
                typedef BumperEvent_DataReader_var _var_type;

                static BumperEvent_DataReader_ptr _duplicate (BumperEvent_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static BumperEvent_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static BumperEvent_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static BumperEvent_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                BumperEvent_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (BumperEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (BumperEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (BumperEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (BumperEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (BumperEvent_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (BumperEvent_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (BumperEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (BumperEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (BumperEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (BumperEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (BumperEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (BumperEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (BumperEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (BumperEvent_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const BumperEvent_& instance) = 0;

            protected:
                BumperEvent_DataReader () {};
                ~BumperEvent_DataReader () {};
            private:
                BumperEvent_DataReader (const BumperEvent_DataReader &);
                BumperEvent_DataReader & operator = (const BumperEvent_DataReader &);
            };

            class  BumperEvent_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef BumperEvent_DataReaderView_ptr _ptr_type;
                typedef BumperEvent_DataReaderView_var _var_type;

                static BumperEvent_DataReaderView_ptr _duplicate (BumperEvent_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static BumperEvent_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static BumperEvent_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static BumperEvent_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                BumperEvent_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (BumperEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (BumperEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (BumperEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (BumperEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (BumperEvent_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (BumperEvent_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (BumperEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (BumperEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (BumperEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (BumperEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (BumperEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (BumperEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (BumperEvent_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (BumperEvent_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const BumperEvent_& instance) = 0;

            protected:
                BumperEvent_DataReaderView () {};
                ~BumperEvent_DataReaderView () {};
            private:
                BumperEvent_DataReaderView (const BumperEvent_DataReaderView &);
                BumperEvent_DataReaderView & operator = (const BumperEvent_DataReaderView &);
            };
        }

    }

}

#endif
