#ifndef _H_3C4F4EEB3387337E07D1732D729B75AC_ControllerInfo__H_
#define _H_3C4F4EEB3387337E07D1732D729B75AC_ControllerInfo__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace kobuki_ros_interfaces
{
    namespace msg
    {
        namespace dds_
        {
            namespace ControllerInfo_Constants
            {
                const ::DDS::Octet DEFAULT_ = 0;

                const ::DDS::Octet USER_CONFIGURED_ = 1;

            }

            struct  ControllerInfo_
            {
                ::DDS::Octet type_;
                ::DDS::Double p_gain_;
                ::DDS::Double i_gain_;
                ::DDS::Double d_gain_;
            };

            typedef DDS_DCPSStruct_var<ControllerInfo_> ControllerInfo__var;
            typedef ControllerInfo_& ControllerInfo__out;

        }

    }

}

#endif /* _H_3C4F4EEB3387337E07D1732D729B75AC_ControllerInfo__H_ */
