#ifndef _H_B7EDC644B2DC97FFB50DBAEDFFF5D73C_KeyboardInput__H_
#define _H_B7EDC644B2DC97FFB50DBAEDFFF5D73C_KeyboardInput__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace kobuki_ros_interfaces
{
    namespace msg
    {
        namespace dds_
        {
            namespace KeyboardInput_Constants
            {
                const ::DDS::Octet KEYCODE_RIGHT_ = 67;

                const ::DDS::Octet KEYCODE_LEFT_ = 68;

                const ::DDS::Octet KEYCODE_UP_ = 65;

                const ::DDS::Octet KEYCODE_DOWN_ = 66;

                const ::DDS::Octet KEYCODE_SPACE_ = 32;

                const ::DDS::Octet KEYCODE_ENABLE_ = 101;

                const ::DDS::Octet KEYCODE_DISABLE_ = 100;

            }

            struct  KeyboardInput_
            {
                ::DDS::Octet pressed_key_;
            };

            typedef DDS_DCPSStruct_var<KeyboardInput_> KeyboardInput__var;
            typedef KeyboardInput_& KeyboardInput__out;

        }

    }

}

#endif /* _H_B7EDC644B2DC97FFB50DBAEDFFF5D73C_KeyboardInput__H_ */
