#ifndef _H_4ECA17C6402DCDC0D5CB9FE357CF71B2_PowerSystemEvent__H_
#define _H_4ECA17C6402DCDC0D5CB9FE357CF71B2_PowerSystemEvent__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace kobuki_ros_interfaces
{
    namespace msg
    {
        namespace dds_
        {
            namespace PowerSystemEvent_Constants
            {
                const ::DDS::Octet UNPLUGGED_ = 0;

                const ::DDS::Octet PLUGGED_TO_ADAPTER_ = 1;

                const ::DDS::Octet PLUGGED_TO_DOCKBASE_ = 2;

                const ::DDS::Octet CHARGE_COMPLETED_ = 3;

                const ::DDS::Octet BATTERY_LOW_ = 4;

                const ::DDS::Octet BATTERY_CRITICAL_ = 5;

            }

            struct  PowerSystemEvent_
            {
                ::DDS::Octet event_;
            };

            typedef DDS_DCPSStruct_var<PowerSystemEvent_> PowerSystemEvent__var;
            typedef PowerSystemEvent_& PowerSystemEvent__out;

        }

    }

}

#endif /* _H_4ECA17C6402DCDC0D5CB9FE357CF71B2_PowerSystemEvent__H_ */
