// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from kobuki_ros_interfaces:msg/VersionInfo.idl
// generated code does not contain a copyright notice
#include "kobuki_ros_interfaces/msg/version_info__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `hardware`
// Member `firmware`
// Member `software`
#include "rosidl_generator_c/string_functions.h"
// Member `udid`
#include "rosidl_generator_c/primitives_sequence_functions.h"

bool
kobuki_ros_interfaces__msg__VersionInfo__init(kobuki_ros_interfaces__msg__VersionInfo * msg)
{
  if (!msg) {
    return false;
  }
  // hardware
  if (!rosidl_generator_c__String__init(&msg->hardware)) {
    kobuki_ros_interfaces__msg__VersionInfo__fini(msg);
    return false;
  }
  // firmware
  if (!rosidl_generator_c__String__init(&msg->firmware)) {
    kobuki_ros_interfaces__msg__VersionInfo__fini(msg);
    return false;
  }
  // software
  if (!rosidl_generator_c__String__init(&msg->software)) {
    kobuki_ros_interfaces__msg__VersionInfo__fini(msg);
    return false;
  }
  // udid
  if (!rosidl_generator_c__uint32__Sequence__init(&msg->udid, 0)) {
    kobuki_ros_interfaces__msg__VersionInfo__fini(msg);
    return false;
  }
  // features
  return true;
}

void
kobuki_ros_interfaces__msg__VersionInfo__fini(kobuki_ros_interfaces__msg__VersionInfo * msg)
{
  if (!msg) {
    return;
  }
  // hardware
  rosidl_generator_c__String__fini(&msg->hardware);
  // firmware
  rosidl_generator_c__String__fini(&msg->firmware);
  // software
  rosidl_generator_c__String__fini(&msg->software);
  // udid
  rosidl_generator_c__uint32__Sequence__fini(&msg->udid);
  // features
}

kobuki_ros_interfaces__msg__VersionInfo *
kobuki_ros_interfaces__msg__VersionInfo__create()
{
  kobuki_ros_interfaces__msg__VersionInfo * msg = (kobuki_ros_interfaces__msg__VersionInfo *)malloc(sizeof(kobuki_ros_interfaces__msg__VersionInfo));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(kobuki_ros_interfaces__msg__VersionInfo));
  bool success = kobuki_ros_interfaces__msg__VersionInfo__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
kobuki_ros_interfaces__msg__VersionInfo__destroy(kobuki_ros_interfaces__msg__VersionInfo * msg)
{
  if (msg) {
    kobuki_ros_interfaces__msg__VersionInfo__fini(msg);
  }
  free(msg);
}


bool
kobuki_ros_interfaces__msg__VersionInfo__Sequence__init(kobuki_ros_interfaces__msg__VersionInfo__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  kobuki_ros_interfaces__msg__VersionInfo * data = NULL;
  if (size) {
    data = (kobuki_ros_interfaces__msg__VersionInfo *)calloc(size, sizeof(kobuki_ros_interfaces__msg__VersionInfo));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = kobuki_ros_interfaces__msg__VersionInfo__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        kobuki_ros_interfaces__msg__VersionInfo__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
kobuki_ros_interfaces__msg__VersionInfo__Sequence__fini(kobuki_ros_interfaces__msg__VersionInfo__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      kobuki_ros_interfaces__msg__VersionInfo__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

kobuki_ros_interfaces__msg__VersionInfo__Sequence *
kobuki_ros_interfaces__msg__VersionInfo__Sequence__create(size_t size)
{
  kobuki_ros_interfaces__msg__VersionInfo__Sequence * array = (kobuki_ros_interfaces__msg__VersionInfo__Sequence *)malloc(sizeof(kobuki_ros_interfaces__msg__VersionInfo__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = kobuki_ros_interfaces__msg__VersionInfo__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
kobuki_ros_interfaces__msg__VersionInfo__Sequence__destroy(kobuki_ros_interfaces__msg__VersionInfo__Sequence * array)
{
  if (array) {
    kobuki_ros_interfaces__msg__VersionInfo__Sequence__fini(array);
  }
  free(array);
}
